# Table of content
* [Introduction](#introduction)
* [Requirement](#requirement)
* [Install all prometheus-operator CRDs](#install-all-prometheus-operator-crds)
* [Prometheus Operator](#prometheus-operator)
* [Example App](#example-app)
* [Servicemonitor](#servicemonitor)
* [Prometheus](#prometheus)
* [Conclusion](#conclusion)

## Introduction
The purpose of demo is to show how to setup manually the prometheus-operator and explain how it works.

## Requirement
- Ingress

## Install all prometheus-operator CRDs
List of CRDs:
- alertmanager: defines a desired Alertmanager deployment.
- prometheus: defines a desired Prometheus deployment
- prometheusrule: defines a desired set of Prometheus alerting and/or recording rules. The Operator generates a rule file, which can be used by Prometheus instances.
- thanosrule: defines a desired Thanos Ruler deployment.
- servicemonitor: declaratively specifies how groups of Kubernetes services should be monitored. The Operator automatically generates Prometheus scrape configuration based on the current state of the objects in the API server.
- podmonitor: same as servicemonito but for pod.

Quick setup:
```
make crd
```

## Prometheus Operator
Prometheus Operator has to access Kubernetes API, nodes, and cluster components, so we should create clusterrole to grant it some permissions. Here are some permissions need to be granted:
- Read access to pods, nodes, and namespaces.
- Read/write access to services and their endpoints.
- Full access to secrets, ConfigMaps , StatefuleSets, Prometheus-related resources (alert managers, service monitors, etc.) and other third-party resources, etc. 

After authorize clusterrole to specific service account (SA), we will create prometheus operator with that SA.

```
    spec:
      containers:
      - args:
        - --kubelet-service=kube-system/kubelet
        - --config-reloader-image=quay.io/coreos/configmap-reload:v0.0.1
        image: quay.io/coreos/prometheus-operator:v0.17.0
        name: prometheus-operator
```

We use the `configmap-reload` image to be able to dynamically update Prometheus ConfigMaps and specify `kube-system/kubelet` in the kubelet-service flag.

- Deploy it by command:
```
make operator
```

## Example App
In order to test our concept, we use image `supergiantkir/prometheus-test-app` to create an application (deployment + service) with metrics path.
- Deploy app:
```
make app
```

## Servicemonitor
Prometheus Operator uses ServiceMonitors to auto-detect target pods based on the label selectors and associate them with the Prometheus instances.
```
apiVersion: monitoring.coreos.com/v1
kind: ServiceMonitor
metadata:
  name: rpc-app
  labels:
    env: production
spec:
  selector:
    matchLabels:
      app: rpc-app
  endpoints:
  - port: web
```
- The ServiceMonitor defined above will select pods labeled `app:rpc-app`.
- The label `env:production` is for the Prometheus later. This label will be used by the Prometheus Operator to find the ServiceMonitor.

Execute this command to create resource:
```
make servicemonitor
```

## Prometheus
Now we create Prometheus resource, same as Prometheus operator, we also create a service account with appropriate clusterrole.
```
- apiGroups: [""]
  resources:
  - nodes
  - nodes/metrics
  - services
  - endpoints
  - pods
  verbs: ["get", "list", "watch"]
- apiGroups: [""]
  resources:
  - configmaps
  verbs: ["get"]
- nonResourceURLs: ["/metrics"]
  verbs: ["get"]
```
And create prometheus with that service account:
```
spec:
  replicas: 1
  serviceAccountName: prometheus
  serviceMonitorSelector:
    matchLabels:
      env: production
  alerting:
    alertmanagers:
    - namespace: operator
      name: alertmanager
      port: web
  additionalScrapeConfigs:
    name: additional-scrape-configs
    key: prometheus-additional.yaml
```
Some to notice:
- `spec.serviceMonitorSelector` to identify which label of servicemonitor that prometheus will take care.
- `spec.additionalScrapeConfigs` allows specifying a key of a Secret containing additional Prometheus scrape configurations. Scrape configurations specified are appended to the configurations generated by the Prometheus Operator. In this demo, we add a simple configuration:
```
- job_name: "prometheus"
  static_configs:
  - targets: ["localhost:9090"]
```
And we create a secret from this:
```
kubectl create secret generic additional-scrape-configs --from-file=prometheus-additional.yaml --dry-run=client -oyaml > additional-scrape-configs.yaml
```
**NOTE:** Use only one secret for ALL additional scrape configurations.
- We use ingress to expose Prometheus with specific host (change your host in env file).
```
apiVersion: extensions/v1beta1
kind: Ingress
metadata:
  annotations:
    kubernetes.io/ingress.class: nginx
  labels:
    app: prometheus
  name: prometheus
  namespace: operator
spec:
  rules:
  - host: prometheus-example
    http:
      paths:
      - backend:
          serviceName: prometheus
          servicePort: 9090
        path: /
```
- After resoure created, Prometheus operator will detect and create a StatefulSet for Prometheus.

Deploy prometheus:
```
make prometheus
```

## Conclusion
By this demo, we can see that Prometheus Operator offers useful way for configuring and managing Prometheus stack. Using the operator means we no longer need to manually configure Kubernetes auto-discovery settings, which involves a lot of stuff. 